<template>
  <div class="home">
    <div v-if="isLoading">Loading ......</div>
    <div v-else>
      <!-- Display List Section -->
      <div v-for="item in getItemsList" :key="item.id">
        {{ item.name }} - {{ item.color }}
        <button @click="deleteItem(item.id)">Delete</button>
      </div>

      <hr />

      <!-- Add Car Section -->
      <form @submit.prevent="onSubmitForm">
        <div>
          name
          <input v-model="car.name" type="text" required />
        </div>
        <div>
          color
          <input v-model="car.color" type="text" required />
        </div>
        <div>
          factory
          <input v-model="car.factory" type="text" required />
        </div>
        <button type="submit">Add</button>
      </form>

      <hr />
    </div>
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';

export default {
  name: 'HomeView',
  data() {
    return {
      car: {
        name: '',
        color: '',
        factory: '',
      },
    };
  },
  computed: {
    ...mapGetters('cars', ['getItemsList', 'isLoading']),
  },
  created() {
    this.loadList();
  },
  methods: {
    ...mapActions('cars', ['loadList', 'addItem', 'deleteItem', 'updateItem', 'loadFilteredData']),
    onSubmitForm() {
      // Ensure that the form is valid before adding a new car
      if (this.isFormValid()) {
        // Add the new car
        this.addItem(this.car);

        // Clear the form fields after successfully adding a car
        this.clearForm();
      }
    },
    isFormValid() {
      // Implement form validation logic if needed
      return true; // Placeholder, replace with actual validation
    },
    clearForm() {
      // Clear form fields
      this.car.name = '';
      this.car.color = '';
      this.car.factory = '';
    },
  },
};
</script>
